/* (C) 2009-2011,2016 Yana */

#if !defined(YK0B_H)
#define YK0B_H

#define YK0B_CONTEXT_EPC 0
#define YK0B_CONTEXT_GPR1 1 /* $at */
#define YK0B_CONTEXT_GPR2 2
#define YK0B_CONTEXT_GPR3 3
#define YK0B_CONTEXT_GPR4 4
#define YK0B_CONTEXT_GPR5 5
#define YK0B_CONTEXT_GPR6 6
#define YK0B_CONTEXT_GPR7 7
#define YK0B_CONTEXT_GPR8 8
#define YK0B_CONTEXT_GPR9 9
#define YK0B_CONTEXT_GPR10 10
#define YK0B_CONTEXT_GPR11 11
#define YK0B_CONTEXT_GPR12 12
#define YK0B_CONTEXT_GPR13 13
#define YK0B_CONTEXT_GPR14 14
#define YK0B_CONTEXT_GPR15 15
#define YK0B_CONTEXT_GPR16 16
#define YK0B_CONTEXT_GPR17 17
#define YK0B_CONTEXT_GPR18 18
#define YK0B_CONTEXT_GPR19 19
#define YK0B_CONTEXT_GPR20 20
#define YK0B_CONTEXT_GPR21 21
#define YK0B_CONTEXT_GPR22 22
#define YK0B_CONTEXT_GPR23 23
#define YK0B_CONTEXT_GPR24 24
#define YK0B_CONTEXT_GPR25 25
#define YK0B_CONTEXT_STATUS 26
#define YK0B_CONTEXT_CAUSE 27
#define YK0B_CONTEXT_GPR28 28 /* $gp */
#define YK0B_CONTEXT_GPR29 29 /* $sp */
#define YK0B_CONTEXT_GPR30 30 /* $fp */
#define YK0B_CONTEXT_GPR31 31 /* $ra */

#define YK0B_CONTEXT_ARGUMENT0 YK0B_CONTEXT_GPR2
#define YK0B_CONTEXT_ARGUMENT1 YK0B_CONTEXT_GPR3
#define YK0B_CONTEXT_ARGUMENT2 YK0B_CONTEXT_GPR4
#define YK0B_CONTEXT_ARGUMENT3 YK0B_CONTEXT_GPR5

#define YK0B_FLAG_KERNEL_MASK (7 << YK0B_FLAG_KERNEL_SHIFT)
#define YK0B_FLAG_KERNEL_SHIFT 0

#define YK0B_FLAG_KERNEL_INTERRUPT (4 << YK0B_FLAG_KERNEL_SHIFT)
#define YK0B_FLAG_KERNEL_RECEIVER (2 << YK0B_FLAG_KERNEL_SHIFT)
#define YK0B_FLAG_KERNEL_SENDER (1 << YK0B_FLAG_KERNEL_SHIFT)

#define YK0B_PROCEDURE_ACCEPT 0
#define YK0B_PROCEDURE_BIT_FLAG 1
#define YK0B_PROCEDURE_CALL 2
#define YK0B_PROCEDURE_CONNECT 3
#define YK0B_PROCEDURE_FORWARD 4
#define YK0B_PROCEDURE_GET_CONTEXT 5
#define YK0B_PROCEDURE_GET_PRIORITY 6
#define YK0B_PROCEDURE_LISTEN 7
#define YK0B_PROCEDURE_REPLY 8
#define YK0B_PROCEDURE_SET_CONTEXT 9
#define YK0B_PROCEDURE_SET_PRIORITY 10

#if !defined(YK0B_PREPROCESS_ONLY)

#include "yk0b_base.h"

typedef yk0b_uint32_t yk0b_context_type_t;
typedef yk0b_uint32_t yk0b_context_value_t;
typedef yk0b_uint32_t yk0b_error_t;
typedef yk0b_uint32_t yk0b_flag_t;
typedef yk0b_uint32_t yk0b_port_t;
typedef yk0b_uint32_t yk0b_priority_t;
typedef yk0b_uint32_t yk0b_task_t;

yk0b_error_t yk0b_accept(yk0b_port_t port, yk0b_task_t *task);
yk0b_error_t yk0b_bit_flag(yk0b_port_t port, yk0b_flag_t flag_off, yk0b_flag_t flag_on, yk0b_flag_t *flag_out);
yk0b_error_t yk0b_call(yk0b_port_t port);
yk0b_error_t yk0b_connect(yk0b_task_t task_replyee, yk0b_task_t task_replyer);
yk0b_error_t yk0b_forward(yk0b_port_t port, yk0b_task_t task);
yk0b_error_t yk0b_get_context(yk0b_task_t task, yk0b_context_type_t type, yk0b_context_value_t *value);
yk0b_error_t yk0b_get_priority(yk0b_task_t task, yk0b_priority_t *priority);
yk0b_error_t yk0b_listen(yk0b_port_t port, yk0b_flag_t flag_wait, yk0b_flag_t *flag_out);
yk0b_error_t yk0b_reply(yk0b_task_t task);
yk0b_error_t yk0b_set_context(yk0b_task_t task, yk0b_context_type_t type, yk0b_context_value_t value_in, yk0b_context_value_t *value_out);
yk0b_error_t yk0b_set_priority(yk0b_task_t task, yk0b_priority_t priority_in, yk0b_priority_t *priority_out);
yk0b_error_t yk0b_get_flag(yk0b_port_t port, yk0b_flag_t *flag);
yk0b_error_t yk0b_set_flag(yk0b_port_t port, yk0b_flag_t flag_in, yk0b_flag_t *flag_out);

#endif

#endif
