/* (C) 2009-2011,2016 Yana */

#include "device.h"
#include "service.h"
#include "start_setup.h"
#include "y_base.h"
#include "y_device.h"
#include "y_queue.h"
#include "y_yanamips.h"
#include "y_yk0b.h"
#include "yanamips.h"
#include "yk0b.h"
#include "yk0b_setup.h"
#include <stddef.h>

#if YK0B_SETUP_EXCEPTION_PORT != YK0B_SETUP_INTERRUPT_PORT
#error YK0B_SETUP_EXCEPTION_PORT != YK0B_SETUP_INTERRUPT_PORT
#endif

typedef struct {
	y_queue_t queue;
} task_control_t;

task_control_t task_control[YK0B_SETUP_TASK_SIZE];

extern y_uint8_t _gp[];

#if defined(__GNUC__)

y_uint8_t task0_stack[TASK0_STACK_SIZE] __attribute__((aligned(Y_STACK_ALIGNMENT)));
y_uint8_t task1_stack[TASK1_STACK_SIZE] __attribute__((aligned(Y_STACK_ALIGNMENT)));

#endif

void task1(void);

void task0(void) {
	y_uint8_t c;
	y_queue_t q;
	y_device_cons_initialize();
	y_device_cons_put_string("(HardwareKernel)");
	yk0b_set_priority(1, 1, NULL);
	y_yk0b_start(1, task1, task1_stack + TASK1_STACK_SIZE / Y_STACK_ALIGNMENT * Y_STACK_ALIGNMENT - Y_STACK_ARGUMENT, _gp, y_yanamips_read_status() | YANAMIPS_STATUS_IE);
	c = 0;
	y_queue_initialize(&q);
	y_yanamips_write_status(y_yanamips_read_status() & ~YANAMIPS_STATUS_IM_MASK | DEVICE_INTERRUPT_CONS << YANAMIPS_STATUS_IM_SHIFT);
	while (1) {
		yk0b_flag_t f;
		yk0b_task_t t;
		yk0b_listen(YK0B_SETUP_EXCEPTION_PORT, ~YK0B_FLAG_KERNEL_RECEIVER, &f);
		if ((f & YK0B_FLAG_KERNEL_SENDER) != 0 && yk0b_accept(YK0B_SETUP_EXCEPTION_PORT, &t) == 0) {
			yk0b_context_value_t cause;
			yk0b_get_context(t, YK0B_CONTEXT_CAUSE, &cause);
			if ((cause & YANAMIPS_CAUSE_EXCCODE_MASK) == 0) {
				y_queue_append(&q, (y_queue_t *)&task_control[t]);
			} else {
				y_device_cons_put_string("{");
				y_device_cons_put_hexadecimal(f);
				y_device_cons_put_string(" ");
				y_device_cons_put_hexadecimal(t);
				y_device_cons_put_string(" ");
				y_device_cons_put_hexadecimal(cause);
				y_device_cons_put_string("}\n");
			}
		}
		if ((f & YK0B_FLAG_KERNEL_INTERRUPT) != 0) {
			c = y_device_cons_getchar();
		}
		if (c != 0 && y_queue_copy(&q) != NULL) {
			t = (task_control_t *)y_queue_remove(&q) - &task_control[0];
			yk0b_set_context(t, YK0B_CONTEXT_ARGUMENT1, c, NULL);
			yk0b_reply(t);
			c = 0;
		}
	}
}

void task1(void) {
	while (1) {
		y_uint8_t c;
		service_getchar(YK0B_SETUP_EXCEPTION_PORT, &c);
		y_device_cons_putchar(c);
	}
}
