/* (C) 2009-2011 Yana */

#if !defined(Y_YANAMIPS_H)
#define Y_YANAMIPS_H

#if !defined(Y_PREPROCESS_ONLY)

#include "y_base.h"
#include "yanamips.h"

#if !defined(__GNUC__)

y_uint32_t y_yanamips_read_badvaddr(void);
y_uint32_t y_yanamips_read_cause(void);
y_uint32_t y_yanamips_read_epc(void);
y_uint32_t y_yanamips_read_status(void);
void y_yanamips_syscall(void);
void y_yanamips_write_badvaddr(y_uint32_t badvaddr);
void y_yanamips_write_cause(y_uint32_t cause);
void y_yanamips_write_epc(y_uint32_t epc);
void y_yanamips_write_status(y_uint32_t status);

#else

__inline__ static y_uint32_t y_yanamips_read_badvaddr(void) {
	y_uint32_t badvaddr;
	__asm__ __volatile__("mfc0 %0, " Y_PREPROCESS_STRING(YANAMIPS_BADVADDR) : "=r"(badvaddr));
	return badvaddr;
}

__inline__ static y_uint32_t y_yanamips_read_cause(void) {
	y_uint32_t cause;
	__asm__ __volatile__("mfc0 %0, " Y_PREPROCESS_STRING(YANAMIPS_CAUSE) : "=r"(cause));
	return cause;
}

__inline__ static y_uint32_t y_yanamips_read_epc(void) {
	y_uint32_t epc;
	__asm__ __volatile__("mfc0 %0, " Y_PREPROCESS_STRING(YANAMIPS_EPC) : "=r"(epc));
	return epc;
}

__inline__ static y_uint32_t y_yanamips_read_status(void) {
	y_uint32_t status;
	__asm__ __volatile__("mfc0 %0, " Y_PREPROCESS_STRING(YANAMIPS_STATUS) : "=r"(status));
	return status;
}

__inline__ static void y_yanamips_syscall(void) {
	__asm__ __volatile__("syscall" : : : "memory");
}

__inline__ static void y_yanamips_write_badvaddr(y_uint32_t badvaddr) {
	__asm__ __volatile__("mtc0 %0, " Y_PREPROCESS_STRING(YANAMIPS_BADVADDR) "; " Y_PREPROCESS_STRING(YANAMIPS_HAZARD_BADVADDR) : : "r"(badvaddr) : "memory");
}

__inline__ static void y_yanamips_write_cause(y_uint32_t cause) {
	__asm__ __volatile__("mtc0 %0, " Y_PREPROCESS_STRING(YANAMIPS_CAUSE) "; " Y_PREPROCESS_STRING(YANAMIPS_HAZARD_CAUSE) : : "r"(cause) : "memory");
}

__inline__ static void y_yanamips_write_epc(y_uint32_t epc) {
	__asm__ __volatile__("mtc0 %0, " Y_PREPROCESS_STRING(YANAMIPS_EPC) "; " Y_PREPROCESS_STRING(YANAMIPS_HAZARD_EPC) : : "r"(epc) : "memory");
}

__inline__ static void y_yanamips_write_status(y_uint32_t status) {
	__asm__ __volatile__("mtc0 %0, " Y_PREPROCESS_STRING(YANAMIPS_STATUS) "; " Y_PREPROCESS_STRING(YANAMIPS_HAZARD_STATUS) : : "r"(status) : "memory");
}

#endif

#endif

#endif
